<?php

/*******************************************************************************
/*******************************************************************************
    doorGets 6.0 - 05, March 2014
    doorgets it's free PHP Open Source CMS PHP & MySQL
    Copyright (C) 2012 - 2014 By Mounir R'Quiba -> Crazy PHP Lover
    
/*******************************************************************************

    Website : http://www.doorgets.com
    Contact : http://www.doorgets.com/?contact
    
/*******************************************************************************
    -= One life, One code =-
/*******************************************************************************
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
******************************************************************************
******************************************************************************/


class Langue extends CRUD{
    
    public  $allLanguages;
    
    public  $allLanguagesWebsite;
    public  $allLanguagesSession;
    
    public  $myLanguage;
   
    public  $configWeb;
    
    public function __construct($lg='fr'){
        
        include BASE.'config/locale.php';
        
        parent::__construct();
        
        $this->myLanguage   = $lg;
        $this->allLanguages = $this->getAllLanguages();
        
        $this->allLanguagesSession = $arrLangue;
        
        $lgTrad     = $this->getLangueTradution();
        $infoWeb    = $this->dbQS(1,'_website');
        
        $infoWebTraduction = $this->dbQS($lgTrad,'_website_traduction','langue');
        if( !empty($infoWeb) && !empty($infoWebTraduction))
        {
            
            $this->configWeb                        = $infoWeb;
            $this->configWeb['statut_tinymce']      =  htmlspecialchars_decode(html_entity_decode($infoWebTraduction['statut_tinymce']));
            $this->configWeb['title']               =  $infoWebTraduction['title'];
            $this->configWeb['slogan']              =  $infoWebTraduction['slogan'];
            $this->configWeb['description']         =  $infoWebTraduction['description'];
            $this->configWeb['copyright']           =  $infoWebTraduction['copyright'];
            $this->configWeb['year']                =  $infoWebTraduction['year'];
            $this->configWeb['keywords']            =  $infoWebTraduction['keywords'];
            $this->configWeb['date_modification']   =  $infoWebTraduction['date_modification'];
            
            $this->configWeb['langue_groupe']        = @unserialize($this->configWeb['langue_groupe']);
            
            foreach($arrLangue as $k=>$v){
                if(
                    !array_key_exists($k,$this->configWeb['langue_groupe'])
                    && $infoWeb['langue_front'] !== $k
                ){
                    unset($arrLangue[$k]);
                }
            }
            
            $this->allLanguagesWebsite = $arrLangue;
        }
        
    }
    
    public function getAllLanguages(){
        
        include BASE.'config/locale.php';
        
        $traductionFile = CONFIGURATION.'traduction.php';
        if(is_file($traductionFile)){
            include $traductionFile;
        }
        
        return $arrLangue;
        
    }
    
    
    public function l($word = ''){
       
        $fileLangue = LANGUE.$this->myLanguage.'.lg.php';
        $fileLanguePrincipale = LANGUE.'temp.lg.php';
        
        if( !is_file($fileLanguePrincipale) || !is_file($fileLangue))
        {
            return $word;
        }
        
        
        
        include $fileLanguePrincipale;
        $wDefaut = $wTranslate;
        
        unset($wTranslate);
        include $fileLangue;
        
        if($word === 'doorgets'){ return 'doorGets'; }
        
        if(in_array($word,$wDefaut)){
            
            $key = array_search($word,$wDefaut);
            
            if( array_key_exists($key,$_w) && !empty($_w[$key]) )
            {
                return $_w[$key];
            }
            
        }
        
        $this->addToTempTranslate($word);
        
        return $word;
        
    }
    
    
    public function myLanguage(){
        
        return $this->myLanguage;
        
    }
    
    public function setLangue($lg="fr"){
        
        $this->myLanguage = $lg;
        
    }
    
    private function addToTempTranslate($word = ''){
        
        $fileTemp = LANGUE.'temp.lg.php';
        if(!empty($word) && is_file($fileTemp)){
            
            include $fileTemp;
            if( isset($wTranslate) && is_array($wTranslate) && !in_array($word,$wTranslate) ){
                
                $wTranslate[] = $word;
                $outTempTranslate = '<?php '."\n";
                foreach($wTranslate as $w){
                    
                    $outTempTranslate .= "\n\t".'$wTranslate[] = "'.$w.'"; ';
                    
                }
                
                @file_put_contents($fileTemp,$outTempTranslate);
            
            }
            
        }
        
    }
    
    public function getLangueTradution(){
        
        $out = $this->myLanguage();
        $iLang = count($this->allLanguagesWebsite);
        
        if( isset($_GET['lg']) && array_key_exists($_GET['lg'],$this->allLanguages)  ){
            
            $out = filter_input(INPUT_GET,'lg',FILTER_SANITIZE_STRING);
            
        }
        if($iLang === 1){
            foreach($this->allLanguagesWebsite as $k=>$v){
                $out = $k;
            }
        }
        return $out;
        
    }
    
    public function genLangueMenuAdmin(){
        
        $i = 0;
        $len = count($this->allLanguagesWebsite);
        
        if(empty($this->allLanguagesWebsite) || $len == 1 ){return '';}
        $out = '<div class="doorGets-langue-menu-admin">';
        
        $url = '?';
        foreach($_GET as $k=>$v){
            if($k !== 'lg'){
                $url .= $k;
                if(!empty($v)){
                    $url .= '='.$v;
                }
                $url .= '&';                
            }

        }
        
        
        
        $out .= '<ul class="nav nav-pills">';
        $out .= '<li><h4>'.$this->l('Traduction').' : </h4></li>';
        foreach($this->allLanguagesWebsite as $k=>$v){
                
            $out .= '<li><a class=" ';
            
            if ($i == 0)
            {
                $out .= ' first ';
                
            }else if ($i == $len - 1)
            {
                $out .= ' last ';
            }
            
            if( (isset($_GET['lg']) && $_GET['lg']===$k) ){
                $out .= ' active';
            }
            
            if( !isset($_GET['lg']) && $k === $this->myLanguage() ){
                $out .= ' active ';
            }
            
            $out .= '" href="'.$url.'lg='.$k.'">'.$v.'</a></li>';
            $i++; 
            
        }
        
        $out .= '</ul></div>';
        
        
        return $out;
        
    }
    
    
    
    public function __destruct(){
        
        parent::__destruct();
    
    }
    
}
























